% randomly generate regression problem
y=randn(20,1);  % Output
X=randn(20,100);% Dictionary

%% solve argmin_beta 1/2||y-X*beta||_2^2 s.t. beta>=0
XtX=X'*X;
Xty=X'*y;
[beta, path, lambda] = NLARS(XtX, Xty,true);

figure; 
plot(lambda,path);
axis tight;
xlabel('lambda','fontweight','bold');
ylabel('coefficients in beta','fontweight','bold');
title(['NLARS regularization path'],'FontWeight','bold');

%% solve argmin_beta 1/2||y-X*beta||_2^2 s.t. beta>=0 
% but stops when a maximum of K non-zero entries in beta has been attained
K=10
[beta, path, lambda] = NLARS(XtX, Xty,true,K);

figure; 
plot(lambda,path);
axis tight;
xlabel('lambda','fontweight','bold');
ylabel('coefficients in beta','fontweight','bold');
title(['NLARS stopped at K=' num2str(K) ' active components'],'FontWeight','bold');




